import { FormSOP } from '../../libappsop/formsop';
import { ListSOP } from '../../libappsop/listsop';
import { DialogOptimizerPuzzles } from '../dialogs/optimizerpuzzles';

export interface ListOptimizerPuzzlesColumn {
  Name?: string;
  Description?: string;
}

export class FormOptimizerPuzzles extends FormSOP {
  public listOptimizerPuzzles = new ListOptimizerPuzzles();
  public constructor() {
    super('FormOptimizerPuzzles');
  }
}

export class ListOptimizerPuzzles extends ListSOP<DialogOptimizerPuzzles, ListOptimizerPuzzlesColumn> {
  public static readonly title = 'Optimizer Puzzles';
  public constructor() {
    super('ListOptimizerPuzzles', new DialogOptimizerPuzzles());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { Name: '' };
  }
}

const listOptimizerPuzzlesContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuOptimizerPuzzles', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuOptimizerPuzzles', Name: 'MenuEdit', Label: 'Edit' },
  Delete: { ContextMenu: 'listContextMenuOptimizerPuzzles', Name: 'MenuDelete', Label: 'Delete' },
  Copy: { ContextMenu: 'listContextMenuOptimizerPuzzles', Name: 'MenuCopy', Label: 'Copy' },
};

export { listOptimizerPuzzlesContextMenuItem as ListOptimizerPuzzlesContextMenuItem };

export enum ListOptimizerPuzzlesOnDrawImage {
  FullyExcluded = 'DELETE2',
  PartiallyIncluded = 'CHECK2_GRAY',
  FullyIncluded = 'CHECK',
  MixIncludedExcluded = 'DOTS',
}
